每日一题:LeetCode-283. 移动零

每日一题系列(day 08)

前言:

🌈 🌈 🌈 🌈 🌈 🌈 🌈 🌈 🌈 🌈 🌈 🌈 🌈

   🔎🔎如果说代码有灵魂,那么它的灵魂一定是👉👉算法👈👈,因此,想要写出💚优美的程序💚,核心算法是必不可少的,少年,你渴望力量吗😆😆,想掌握程序的灵魂吗❓❗️那么就必须踏上这样一条漫长的道路🏇🏇,我们要做的,就是斩妖除魔💥💥,打怪升级!💪💪当然切记不可😈走火入魔😈,每日打怪,拾取经验,终能成圣🙏🙏!开启我们今天的斩妖之旅吧!✈️✈️


题目:

给定一个数组 nums,编写一个函数将所有 0 移动到数组的末尾,同时保持非零元素的相对顺序。请注意 ,必须在不复制数组的情况下原地对数组进行操作。

示例:

提示:

  • 1 <= nums.length <= 104
  • -231 <= numsi <= 231 - 1

思路:

  这题其实很简单,题目要求我们在不改变原有数组的顺序下将零元素全部移动到数组的最右侧。我把这类题目称为划分数组的题目,而解决这类将数组划分为几个区域的问题,我们经常会使用双指针算法。

  首先题目给我们一个数组,让我们最终得到的结果被划分成两个区间,一个是元素为0的区间,一个是元素不为0的区间。但是这是将数组最终得到的结果,在我们没划分完的时候我们其实可以分为三个区间:

  首先我们先设置一个指针cur用来遍历这个数组,一个指针dest表示已处理的非零元素的最后一个位置。在cur走完之前其实可以分为三个区间:

  当cur走完之后就只剩下两个区间:

  开始,dest指向-1,cur从0开始往后遍历,只要遇到不是0元素就先将dest+1(因为开始指向-1,所以每次交换前要先+1)在交换这两个值,到cur指向n的时候遍历结束,我们就得到了目标结果。

  其实这个过程仔细观察,我们会发现其实这个过程和我们的快排很类似,快排是选取一个基准值将小于基准值的放左区间,大于基准值的放右区间。对于这题来说,基准值就是0。只不过大于0的在左边而已。

代码实现:

cpp 复制代码
class Solution {
public:
    void moveZeroes(vector<int>& nums) {
        int cur = 0;
        int dest = -1;//首先指向-1
        while(cur != nums.size())//cur不超过数组下标范围就循环
        {
            if(nums[cur])//不为0就交换
            {
                swap(nums[++dest], nums[cur]);//别忘记++dest
            }
            ++cur;//最后cur向后走一步
        }
    }
};

  双指针问题在数组划分类似的问题中非常常见,双指针并不一定是C语言语法中的指针,可以是数组下标,或者某个索引等...

相关推荐
严肃小白兔2 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
青少儿编程课堂3 小时前
蓝桥杯青少组图形化省考报名倒计时·全国青少年信息素养大赛·电子学会图形化考级:校园黑白棋人机对战解析
c++·python·算法·bfs·信息学竞赛
jktantan4 小时前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构
Dream it possible!16 小时前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划
心抵鹊17 小时前
算法之双指针系列(一)
算法·leetcode
十二17 小时前
【洛谷题解】P1083 [NOIP 2012 提高组] 借教室(二分答案 + 差分)
数据结构·c++·算法·蓝桥杯
小此方18 小时前
[算法实战论:动态规划]回文串问题的dp解法,回文串问题的母题,以及以此为基础的派生题
算法·动态规划
Pniubi19 小时前
力扣560.和为k的子数组
算法·leetcode·职场和发展
D e re k ZH19 小时前
C++ 从零入门(一):基础语法与程序结构
数据结构·c++·算法
Pniubi19 小时前
力扣438.找到字符串中所有字母异位词
算法·leetcode·职场和发展